#ifndef LIFO_IMPL_H
#define LIFO_IMPL_H

#include "wyjatki.h"

namespace cont
{
    //konstruktor
    template<class El> Lifo<El>::Lifo(int size)
        : size_(size), pos_(0)
    {
        if(size <= 0)
            throw BadSizeException( reinterpret_cast<long>(this), size_);
        tab_ = new El[size_];
    }

    //konstruktor kopiujacy
    template<class El> Lifo<El>::Lifo(const Lifo& l)
    {
        tab_ = 0L;
        size_ = 0;
        pos_ = 0;
        //ZAIMPLEMENTOWAC
    }

    //operator przypisania
    template<class El> Lifo<El>& Lifo<El>::operator=(const Lifo& l)
    {
        //ZAIMPLEMENTOWAC
        return *this;
    }

    template<class El> Lifo<El>::~Lifo()
    {
        delete [] tab_;
        tab_ = 0L;
    }

    template<class El> Lifo<El>& Lifo<El>::push(const El& el)
    {
		//ZAIMPLEMENTOWAC
		//ODKOMENTOWAC
		//		if(pos_ == size_ )
		//			throw FullLifoException( reinterpret_cast<long>(this), pos_);
        tab_[pos_++] = el;
        return *this;
    }


    template<class El> Lifo<El>& Lifo<El>::pop(El& el)
    {
        if(pos_ == 0 )
            throw EmptyLifoException(reinterpret_cast<long>(this) );

        el = tab_[--pos_];
        return *this;
    }

    template<class El> void Lifo<El>::write(std::ostream& os) const
	{
		os << "Elementow: " << pos_ << '/' << size_ << std::endl;
		for(int i = 0; i < pos_; i++)
			os << tab_[i] << ' ';
		os << std::endl;
	}

}

#endif
