
/* Robert Nowak, PROBI, 2005-12-15, 19:00
   wzorce, wyjatki */
/*
  ZADANIA:
  1. Przeanalizowac dostarczony przyklad.
  2. Uzupelnic implementacje klasy wyjatku EmptyLifoException.
  3. Zaimplementowac klase wyjatku FullLifoException.
  4. Uzupelnic implementacje metody Lifo::push, tak aby generowala wyjatek FullLifoException.
  5. Uzupelnic program testujacy, funkcja 'testuj' tak, aby wypisywala odp. komunikat.
*/

#include <iostream>
#include <vector>

#include "wyjatki.h"
#include "lifo.h"

using namespace cont;
using namespace std;

typedef Lifo<int> LifoInt;

void test1()
{
    LifoInt a(-1);
}

void test2()
{
    LifoInt b(2);
    b.push(1);
    b.push(1);
    b.push(1);
    int ret;
    b.pop(ret);
}

void test3()
{
    LifoInt d(4);
    int ret;
    d.pop(ret);
}

void testuj( void (*pf)(void) )
{
    //uzupelnic implementacje.
    //wypisac odpowiedni komunikat o bledach ( w zaleznosci od typu wyjatku )
    //na cout
    pf();
}

int main()
{
    try
    {
		cout << "Test1" << endl;
		testuj(test1);
		cout << "Test2" << endl;
		testuj(test2);
		cout << "Test3" << endl;
		testuj(test3);
    }
    catch(...)
    {
        cout << "To nie powinno sie pojawic! Nie wylapano jakiegos wyjatku!" << endl;
    }
    return 0;
}

